Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/ManagedPoolProvider.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/ManagedPoolProvider.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/ManagedPoolProvider.cs	(revision 14777)
@@ -8,12 +8,15 @@
   using System.Runtime.Serialization.Formatters.Binary;
 
-  public interface IManagedPool<T> : IDisposable where T : class {
-    T Get();
+  public interface IManagedPool<T> : IDisposable where T : class, IPooledObject {
+    T Get(bool reset = true);
   }
 
-  public class ManagedPoolProvider<T> where T : class {
+  public class ManagedPoolProvider<T> where T : class, IPooledObject {
     private readonly ConcurrentStack<T[]> partitions = new ConcurrentStack<T[]>();
     private readonly ObjectPool<IManagedPool<T>> managedPools;
-    private T[] DummyPartition;
+    private readonly BinaryFormatter binaryFormatter = new BinaryFormatter();
+    private byte[] dummyPartition;
+
+    private readonly Func<T> factory;
 
     public readonly int PartitionSize;
@@ -21,20 +24,25 @@
     public const int DefaultMaxInstanceCount = 65536;
 
-    public ManagedPoolProvider(int partitionSize, int? maxPartitionCount = null) {
+    public ManagedPoolProvider(int partitionSize, Func<T> factory, int? maxPartitionCount = null) {
       PartitionSize = partitionSize;
       MaxParitionCount = maxPartitionCount ?? DefaultMaxInstanceCount / PartitionSize;
+      this.factory = factory;
 
-      managedPools = new ObjectPool<IManagedPool<T>>(() => new ManagedPool<T>(this));
+      managedPools = new ObjectPool<IManagedPool<T>>(() => new ManagedPool<T>(this), MaxParitionCount);
     }
+    public int InstanceCount { get { return partitions.Count * PartitionSize; } }
 
-    public void InitDummyPartition(Func<T> factory) {
-      DummyPartition = new T[PartitionSize];
+    private void InitDummyPartition(Func<T> factory) {
+      var temp = new T[PartitionSize];
 
       for (var i = 0; i < PartitionSize; i++) {
-        DummyPartition[i] = factory();
+        temp[i] = factory();
+      }
+
+      using (var memoryStream = new MemoryStream()) {
+        binaryFormatter.Serialize(memoryStream, temp);
+        dummyPartition = memoryStream.ToArray();
       }
     }
-
-    public int InstanceCount { get { return partitions.Count * PartitionSize; } }
 
     public void ReleasePartitions(params T[][] partition) {
@@ -45,11 +53,12 @@
     private T[] GetPartition() {
       T[] partition;
-      return partitions.TryPop(out partition) ? partition : DeepArrayCopy(DummyPartition);
+      return partitions.TryPop(out partition) ? partition : CloneDummyPartition();
     }
 
-    private readonly BinaryFormatter binaryFormatter = new BinaryFormatter();
-    private T[] DeepArrayCopy(object objectToCopy) {
-      using (var memoryStream = new MemoryStream()) {
-        binaryFormatter.Serialize(memoryStream, objectToCopy);
+    private T[] CloneDummyPartition() {
+      if (dummyPartition == null)
+        InitDummyPartition(factory);
+
+      using (var memoryStream = new MemoryStream(dummyPartition)) {
         memoryStream.Seek(0, SeekOrigin.Begin);
 
@@ -62,5 +71,5 @@
     }
 
-    private class ManagedPool<T> : IManagedPool<T> where T : class {
+    private class ManagedPool<T> : IManagedPool<T> where T : class, IPooledObject {
       private readonly ManagedPoolProvider<T> provider;
       private readonly IList<T[]> partitions = new List<T[]>();
@@ -73,5 +82,5 @@
       }
 
-      public T Get() {
+      public T Get(bool reset = true) {
         if (entryIndex == provider.PartitionSize) {
           currentPartition = provider.GetPartition();
@@ -80,5 +89,9 @@
         }
 
-        return currentPartition[entryIndex++];
+        var entry = currentPartition[entryIndex++];
+
+        if (reset) entry.Reset();
+
+        return entry;
       }
 
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/ObjectPool.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/ObjectPool.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/ObjectPool.cs	(revision 14777)
@@ -25,5 +25,5 @@
   ///    If there is no intent for reusing the object, do not use pool - just use "new".
   /// </summary>
-  internal sealed class ObjectPool<T> where T : class {
+  public sealed class ObjectPool<T> where T : class {
     private struct Element {
       internal T Value;
@@ -39,8 +39,8 @@
 
 
-    internal ObjectPool(Func<T> factory)
+    public ObjectPool(Func<T> factory)
         : this(factory, Environment.ProcessorCount * 2) { }
 
-    internal ObjectPool(Func<T> factory, int size) {
+    public ObjectPool(Func<T> factory, int size) {
       _factory = factory;
       _items = new Element[size];
@@ -60,5 +60,5 @@
     /// reducing how far we will typically search.
     /// </remarks>
-    internal T Allocate() {
+    public T Allocate() {
       var items = _items;
       T inst;
@@ -90,5 +90,5 @@
     /// reducing how far we will typically search in Allocate.
     /// </remarks>
-    internal void Free(T obj) {
+    public void Free(T obj) {
       var items = _items;
       for (int i = 0; i < items.Length; i++) {
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/PooledList.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/PooledList.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/PooledList.cs	(revision 14777)
@@ -0,0 +1,12 @@
+﻿using System.Collections.Generic;
+
+namespace HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool {
+  using System;
+
+  [Serializable]
+  public class PooledList<T> : List<T>, IPooledObject {
+    public void Reset() {
+      this.Clear();
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Tree/Tree.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Tree/Tree.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Tree/Tree.cs	(revision 14777)
@@ -0,0 +1,4 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Data.Tree {
+  public class Tree<T> : TreeNode<T> {
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Tree/TreeExtensions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Tree/TreeExtensions.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Tree/TreeExtensions.cs	(revision 14777)
@@ -0,0 +1,71 @@
+﻿using System;
+using System.Collections.Generic;
+
+namespace HeuristicLab.Problems.ProgramSynthesis.Push.Data.Tree {
+  using System.Linq;
+
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+
+  public static class TreeExtensions {
+    public static Tree<T> ToTree<T>(
+      this IEnumerable<T> items,
+      Predicate<T> isChild,
+      Func<T, IReadOnlyList<T>> childrenResolver) {
+      var tree = new Tree<T>();
+
+      foreach (var item in items) {
+        if (isChild(item)) {
+          var subNode = childrenResolver(item).ToTree(isChild, childrenResolver);
+          subNode.Value = item;
+          tree.AddNode(subNode);
+        } else {
+          tree.Add(item);
+        }
+      }
+
+      return tree;
+    }
+
+    public static IEnumerable<TreeNode<T>> DepthFirst<T>(this TreeNode<T> node) {
+      foreach (var child in node.Children) {
+        if (child.Children.Count > 0) {
+          foreach (var subChild in child.DepthFirst()) {
+            yield return subChild;
+          }
+        } else yield return child;
+      }
+    }
+
+    public static IEnumerable<T> DepthFirst<T>(this TreeNode<T> node, Func<IEnumerable<T>, T> resolveParent) {
+      foreach (var child in node.Children) {
+        if (child.Children.Count > 0) {
+          var subExpressions = child.DepthFirst(resolveParent);
+          yield return resolveParent(subExpressions);
+        } else yield return child.Value;
+      }
+    }
+
+    public static PushProgram ToPushProgram(this TreeNode<Expression> tree, Func<Expression, bool> condition = null) {
+      var expressions = tree.DepthFirst(e => ResolveProgram(e, condition));
+
+      return ResolveProgram(expressions, condition);
+    }
+
+    public static Tree<Expression> ToTree(this PushProgram program) {
+      var tree = program.Expressions.ToTree(e => e.IsProgram, e => ((PushProgram)e).Expressions);
+      tree.Value = program;
+
+      return tree;
+    }
+
+    private static PushProgram ResolveProgram(IEnumerable<Expression> expressions, Func<Expression, bool> condition = null) {
+
+      if (condition != null) {
+        expressions = expressions.Where(condition);
+      }
+
+      return new PushProgram(expressions.ToArray());
+    }
+  }
+
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Tree/TreeNode.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Tree/TreeNode.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Tree/TreeNode.cs	(revision 14777)
@@ -0,0 +1,28 @@
+﻿using System.Collections.Generic;
+
+namespace HeuristicLab.Problems.ProgramSynthesis.Push.Data.Tree {
+  public class TreeNode<T> {
+    public T Value { get; set; }
+    public IList<TreeNode<T>> Children { get; private set; }
+
+    public TreeNode() {
+      Children = new List<TreeNode<T>>();
+    }
+
+    public TreeNode(T value) : this() {
+      Value = value;
+    }
+
+    public void Add(T value) {
+      this.Children.Add(new TreeNode<T>(value));
+    }
+
+    public void AddNode(TreeNode<T> node) {
+      this.Children.Add(node);
+    }
+
+    public void ReplaceNode(int index, TreeNode<T> node) {
+      Children[index] = node;
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/BooleanExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/BooleanExpressions.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/BooleanExpressions.cs	(revision 14777)
@@ -1,11 +1,13 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+  using System;
+
+  using Attributes;
+  using Interpreter;
+  using Stack;
 
   /// <summary>
   ///     Pushes the logical AND of the top two BOOLEANs.
   /// </summary>
-  [PushExpression(StackType.Boolean, "BOOLEAN.AND")]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.AND")]
   public class BooleanAndExpression : PushResultExpression<bool> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -17,5 +19,5 @@
   ///     Pushes the logical OR of the top two BOOLEANs.
   /// </summary>
-  [PushExpression(StackType.Boolean, "BOOLEAN.OR")]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.OR")]
   public class BooleanOrExpression : PushResultExpression<bool> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -27,5 +29,5 @@
   ///     Pushes the logical NOT of the top BOOLEAN.
   /// </summary>
-  [PushExpression(StackType.Boolean, "BOOLEAN.NOT")]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.NOT")]
   public class BooleanNotExpression : PushResultExpression<bool> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -37,10 +39,10 @@
   ///     Pushes FALSE if the top FLOAT is 0.0, or TRUE otherwise.
   /// </summary>
-  [PushExpression(StackType.Boolean, "BOOLEAN.FROMFLOAT")]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.FROMFLOAT", StackTypes.Float)]
   public class BooleanFromFloatExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
       if (interpreter.FloatStack.Count == 0) return false;
 
-      var value = interpreter.FloatStack.Pop() != 0.0;
+      var value = Math.Abs(interpreter.FloatStack.Pop()) > 0.0000001;
 
       interpreter.BooleanStack.Push(value);
@@ -52,5 +54,5 @@
   ///     Pushes FALSE if the top INTEGER is 0, or TRUE otherwise.
   /// </summary>
-  [PushExpression(StackType.Boolean, "BOOLEAN.FROMINTEGER")]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.FROMINTEGER", StackTypes.Integer)]
   public class BooleanFromIntegerExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -63,3 +65,34 @@
     }
   }
+
+  /// <summary>
+  ///     Pushes the logical AND of the top two BOOLEANs, whereby the first value is inverted first.
+  /// </summary>
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.INVERT_FIRST_THEN_AND")]
+  public class BooleanInvertFirstThenAnd : PushResultExpression<bool> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.BooleanStack, 2, values => !values[0] && values[1]);
+    }
+  }
+
+  /// <summary>
+  ///     Pushes the logical AND of the top two BOOLEANs, whereby the second value is inverted first.
+  /// </summary>
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.INVERT_SECOND_THEN_AND")]
+  public class BooleanInvertSecondThenAnd : PushResultExpression<bool> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.BooleanStack, 2, values => values[0] && !values[1]);
+    }
+  }
+
+
+  /// <summary>
+  ///     Pushes the logical AND of the top two BOOLEANs, whereby the second value is inverted first.
+  /// </summary>
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.XOR")]
+  public class BooleanXorExpression : PushResultExpression<bool> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.BooleanStack, 2, values => values[0] ^ values[1]);
+    }
+  }
 }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CharExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CharExpressions.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CharExpressions.cs	(revision 14777)
@@ -0,0 +1,78 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+  using System;
+
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+
+  [PushExpression(StackTypes.Char, "CHAR.ISWHITESPACE", StackTypes.Boolean)]
+  public class CharIsWhitespaceExpression : StatelessExpression {
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.CharStack.IsEmpty) return false;
+
+      var c = interpreter.CharStack.Pop();
+      interpreter.BooleanStack.Push(char.IsWhiteSpace(c));
+      return true;
+    }
+  }
+
+  [PushExpression(StackTypes.Char, "CHAR.ISLETTER", StackTypes.Boolean)]
+  public class CharIsLetterExpression : StatelessExpression {
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.CharStack.IsEmpty) return false;
+
+      var c = interpreter.CharStack.Pop();
+      interpreter.BooleanStack.Push(char.IsLetter(c));
+      return true;
+    }
+  }
+
+  [PushExpression(StackTypes.Char, "CHAR.ISDIGIT", StackTypes.Boolean)]
+  public class CharIsDigitExpression : StatelessExpression {
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.CharStack.IsEmpty) return false;
+
+      var c = interpreter.CharStack.Pop();
+      interpreter.BooleanStack.Push(char.IsDigit(c));
+      return true;
+    }
+  }
+
+  [PushExpression(StackTypes.Char, "CHAR.FROMINTEGER", StackTypes.Integer)]
+  public class CharFromIntegerExpression : StatelessExpression {
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.IntegerStack.IsEmpty) return false;
+
+      var value = (int)Math.Abs(interpreter.IntegerStack.Pop() % 128);
+      var c = Convert.ToChar(value);
+
+      interpreter.CharStack.Push(c);
+      return true;
+    }
+  }
+
+  [PushExpression(StackTypes.Char, "CHAR.FROMFLOAT", StackTypes.Float)]
+  public class CharFromFloatExpression : StatelessExpression {
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.FloatStack.IsEmpty) return false;
+
+      var value = (int)Math.Abs(interpreter.FloatStack.Pop() % 128);
+      var c = Convert.ToChar(value);
+
+      interpreter.CharStack.Push(c);
+      return true;
+    }
+  }
+
+  [PushExpression(StackTypes.Char, "CHAR.ALLFROMSTRING", StackTypes.String)]
+  public class CharAllFromStringExpression : StatelessExpression {
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.StringStack.IsEmpty) return false;
+
+      var chars = interpreter.StringStack.Pop().ToCharArray();
+      interpreter.CharStack.Push(chars);
+      return true;
+    }
+  }
+
+}
